//
//  HomeInteractor.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/5/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxSwift

protocol HomeInteractorInterface: InteractorInterface {
    func getPlugins() -> Observable<[HomeSectionPlugin]>
}

final class HomeInteractor {
}

// MARK: - Extensions -

extension HomeInteractor: HomeInteractorInterface {
    func getPlugins() -> Observable<[HomeSectionPlugin]> {
        return Observable.just(
            [
                HomeSectionItem(code: .bannerSection, extraData: [:]),
                HomeSectionItem(code: .mediumCarouselSection, extraData: [:]),
                HomeSectionItem(code: .mediumCarouselSection, extraData: [:]),
                
                HomeSectionItem(code: .largeCarouselSection, extraData: [:]),
                HomeSectionItem(code: .largeCarouselSection, extraData: [:]),
                HomeSectionItem(code: .largeSingleCarouselSection, extraData: [:]),
                HomeSectionItem(code: .gridViewSection, extraData: [:]),
                HomeSectionItem(code: .mediumCarouselSection, extraData: [:]),
                HomeSectionItem(code: .gridViewSection, extraData: [:]),
                HomeSectionItem(code: .circleCarouselSection, extraData: [:])
            ]
        )
        .map { sectionItems -> [HomeSectionPlugin] in
            return sectionItems
                .compactMap { sectionItem -> HomeSectionPlugin? in
                    let plugin = HomeSectionPlugins.registeredPluginsMapping[sectionItem.code]
                    plugin?.extraData = sectionItem.extraData
                    return plugin
                }
        }
    }
}
